#include "trithorpe.h"


int expect_error;
int count_error;
int count_expected_error;

void bad()
{
    ++count_error;
#ifdef DEBUG
    fprintf(stderr, "DEBUG -- STOPPING ON BAD\n");
    abort();
#endif
}				// a place to breakpoint

char* bogusPtr= 0;
void bomb(const char*s)
{
    fprintf(stderr, "BOMBING <%s>\n", s);
    fprintf(stderr, "BOMBING <%s> <%c>\n", s, *bogusPtr);
    //Say(s);
    bad();

    abort();
}

bool assert_must(bool a, const char *A, int line, const char *file,
		 const char *F)
{
    if (!a) {
	if (expect_error) {
	    ++count_expected_error;
	} else {
	    fprintf(stderr,
		    "%s(%d): %s: assertion failed ..... %s .....\n", file,
		    line, F, A);
	    bad();
	    return false;
	}
    }
    return true;
}

bool assert_eq(tri a, tri b, const char *A, const char *B, int line,
	       const char *file, const char *F)
{
    bool z= assert_eq( a.peek(), b.peek(), A, B, line, file, F);
    if (!z) { say << "... " << a << b << '\n' ;}
    return z;
}


bool assert_ne(tri a, tri b, const char *A, const char *B, int line,
	       const char *file, const char *F)
{
    bool z= assert_ne( a.peek(), b.peek(), A, B, line, file, F);
    if (!z) { say << "... " << a << b << '\n' ;}
    return z;
}


bool assert_eq(word a, word b, const char *A, const char *B, int line,
	       const char *file, const char *F)
{
    if (a != b) {
	if (expect_error) {
	    ++count_expected_error;
	} else {
	    fprintf(stderr,
		    "%s(%d): %s: assertion failed ..... %s == %s ..... 0x%lx != 0x%lx .....\n",
		    file, line, F, A, B, (long) a, (long) b);
	    bad();
	    return false;
	}
    }
    return true;
}

bool assert_ne(word a, word b, const char *A, const char *B, int line,
	       const char *file, const char *F)
{
    if (a == b) {
	if (expect_error) {
	    ++count_expected_error;
	} else {


	    fprintf(stderr,
		    "%s(%d): %s: assertion failed ..... %s != %s ..... 0x%lx == 0x%lx .....\n",
		    file, line, F, A, B, (long) a, (long) b);
	    bad();
	    return false;
	}
    }
    return true;
}

void Say(const char *s)
{
    fprintf(stderr, "%s\n", s);
}

void memcheck() {
    EQ(tab::countCtors, tab::countDtors);
    EQ(count_new, count_delete);
    EQ(count_new_array, count_delete_array);
}

bool runUnitTests= false;

int trimain(int argc, const char * argv[]);

int main(int argc, const char * argv[])
{
    extern void RunAllTests(void);

    if (argc>1 && argv[1][0]=='-' && argv[1][1]=='t') {

	argv[1]=argv[0], argc--, argv++;

	runUnitTests= true;
	RunAllTests();
    }

    EQ(tab::countCtors, tab::countDtors);
    EQ(count_new, count_delete);
    EQ(count_new_array, count_delete_array);

    if ( count_error > 0 ) {
	fprintf( stderr, "Failed tests.\n" );
	return 7;
    }

    if (runUnitTests) Say("...MAIN\n");

    int status= trimain(argc, argv);

    EQ(tab::countCtors, tab::countDtors);
    EQ(count_new, count_delete);
    EQ(count_new_array, count_delete_array);

    return status;
}
