#include <unistd.h>
#include <stdio.h>

#include "trithorpe.h"

TriTerp* T;

void showStack() { T->dumpStack(); }

int 
trimain(int argc, const char* argv[])
{

#define BIG 999999

    char buf[ BIG ];

    int cc= read( 0, buf, sizeof buf );

    buf[cc]= '\0';

    TriTerp terp;
    T= &terp; // for gdb

    // Argc
    terp.home.aStore( tri('A','r','g','c'), tri(argc) );

    // argv
    for (int i=0; i<argc; i++) {
	terp.home.aPut( i, tri( argv[i] ) );
    }

    // Putc() hack
    terp.home.aStore( tri('P','u','t','c'), tri("tcod putc 10240 ret") );

    tri program= tri::NewCodVec(buf);
    tri code("tcod");

    Compiler piler(program, code, terp.home );
    char* VERBOSE =  getenv("VERBOSE");
    verbose= atoi( VERBOSE ? VERBOSE : "0" );
    //piler.compileFuncs();
    Expr* list= piler.parseExprList();
    err e= list->emitGet();
    if (verbose) dumpVec( code, "stdin" );
    delete list;

    e= terp.testEval( code, NIL, NIL );
    if ( e != tri() ) { say << "\n*** ERROR " << e << "\n";  bomb("trimain: eval stdin returns error"); }

    if (verbose) dumpVec( terp.home, "Home" );

    return 0;
}
